Subject: Re: [xmpp] mutual auth for s2s

From: Peter Saint-Andre <[email-masked]>
Date: Fri, 16 Apr 2010 13:32:23 -0600

On 3/30/10 10:21 PM, Peter Saint-Andre wrote:
> On 3/26/10 10:23 AM, Dave Cridland wrote:
>> On Fri Mar 26 15:42:56 2010, Peter Saint-Andre wrote:
>>> I think the peer is communicating
>>> that it is willing to allow the stream to be bidirectional.
>>
>> Right, that's all that's needed - it's just mechanics, not security.
>>
>> The thing is, from a security standpoint, both initiator and the
>> receiver must have authenticated the other party. Otherwise, why is the
>> initiator still sending stanzas, and why is the receiver accepting them?
>>
>> Basically I cannot see any case when the receiver is happy to accept
>> stanzas from the initiator - and the intitiator is happy to send them -
>> yet the reverse is not true.
>>
>> So the way I'd do this is to have a stream feature:
>>
>>  <bidi xmlns='urn:xmpp:bidi'/>
>>
>> A top-level element to turn request it:
>>
>>  <bidi xmlns='urn:xmpp:bidi'/>
>>
>> And a response:
>>
>>  <success xmlns='urn:xmpp:bidi'/>
>>  <failure xmlns='urn:xmpp:bidi'/>
>>
>> I don't see the need for anything else - moreover, these could be
>> pipelined easily, so don't actually represent a new round-trip.
> 
> So this sounds like an XMPP extension, not something that belongs in
> rfc3920bis. Correct? If so, feel free to write up a proposal and submit
> it to mailto:[email-masked]... :)

I've been thinking about this some more and it's core enough that I
think it belongs in 3920bis -- after all, we're talking about a way to
control the directionality of the stream, not some payload within a
stanza. I will probably try to work this into the next version of the spec.

Peter

-- 
Peter Saint-Andre
https://stpeter.im/